<template>
  <div id="activeConfiguration">
    <search-box :formList="formList" @search="search" @init="init" />
    <table-list
      :tableSets="tableSet"
      :tableData="tableData"
      :navText="navText"
      @addClick="addClick"
      :loading="loading"
    >
      <template slot="btn" slot-scope="props">
        <el-button
          type="text"
          @click="changeStatus(props.scope.row, 3)"
          v-if="props.scope.row.status === 2 || props.scope.row.status === 4"
          >开始</el-button
        >
        <el-button
          type="text"
          @click="changeStatus(props.scope.row, 1)"
          v-if="props.scope.row.status === 3"
          >结束</el-button
        >
        <el-button type="text" @click="addClick(props.scope.row, 2)"
          >详情</el-button
        >
        <el-button
          type="text"
          @click="changeStatus(props.scope.row, 2)"
          v-if="props.scope.row.status === 3"
          >撤回</el-button
        >
        <el-button
          type="text"
          @click="addClick(props.scope.row, 0)"
          v-if="props.scope.row.status === 2 || props.scope.row.status === 4"
          >修改</el-button
        >
        <el-button
          type="text"
          @click="changeStatus(props.scope.row, 0)"
          v-if="props.scope.row.status === 4"
          >删除</el-button
        >
      </template>
    </table-list>
    <pagination
      :total="total"
      :pageSize="pageSize"
      :currentPage="currentPage"
      @handleSizeChange="handleSizeChange"
      @handleCurrentChange="handleCurrentChange"
    />
    <el-dialog
      :visible.sync="dialogBox"
      width="920px"
      :show-close="false"
      :destroy-on-close="true"
      :before-close="closeBefore"
      :fullscreen="fullscreen"
    >
      <div slot="title" class="hearders">
        <div class="leftTitle">
          {{ statusPop === 1 ? "添加" : statusPop === 0 ? "修改" : "详情" }}
        </div>
        <div class="rightBoxs">
          <img
            src="@/assets/images/Max@2x.png"
            alt=""
            @click="fullscreen = !fullscreen"
          />
          <img src="@/assets/images/Close@2x.png" alt="" @click="closeBefore" />
        </div>
      </div>
      <el-row class="contentBox" :span="24">
        <el-col :span="12">
          <el-col :span="24">
            <header>活动名称：</header>
            <el-input
              :disabled="statusPop === 2"
              placeholder="请输入活动名称"
              v-model="formLabelAlign.activityName"
          /></el-col>
          <el-col :span="24">
            <header>活动链接：</header>
            <el-input
              :disabled="statusPop === 2"
              placeholder="请输入活动链接"
              v-model="formLabelAlign.activityUrl"
            />
          </el-col>
          <el-col :span="24">
            <header>活动类型：</header>
            <el-select
              style="width: 100%"
              v-model="formLabelAlign.activityType"
              placeholder="请选择活动类型"
              :disabled="statusPop === 2"
            >
              <el-option
                v-for="item in activityList"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-col>
          <el-col :span="24" v-if="formLabelAlign.activityType !== 2">
            <header>活动范围：</header>
            <el-select
              style="width: 100%"
              multiple
              v-model="formLabelAlign.courses"
              placeholder="请选择活动类型"
              :disabled="statusPop === 2"
            >
              <el-option
                v-for="(item, index) in courseList"
                :key="index"
                :label="item.courseName"
                :value="item.courseId"
              >
              </el-option>
            </el-select>
          </el-col>
          <el-col :span="24" v-if="formLabelAlign.activityType !== 2">
            <header>
              {{
                formLabelAlign.activityType === 0
                  ? "金额"
                  : formLabelAlign.activityType === 1
                  ? "折扣"
                  : formLabelAlign.activityType === 3
                  ? "商品金额"
                  : formLabelAlign.activityType === 4
                  ? "优惠金额"
                  : formLabelAlign.activityType === 5
                  ? "商品折扣"
                  : "未定义"
              }}：
            </header>
            <el-input
              placeholder="请输入"
              v-model="formLabelAlign.price"
              :disabled="statusPop === 2"
            >
              <template slot="append">{{
                formLabelAlign.activityType === 0 ||
                formLabelAlign.activityType === 3 ||
                formLabelAlign.activityType === 4 ||
                formLabelAlign.activityType === 5
                  ? "￥"
                  : "折"
              }}</template>
            </el-input>
          </el-col>
          <el-col
            :span="24"
            v-if="
              formLabelAlign.activityType === 0 ||
              formLabelAlign.activityType === 1
            "
          >
            <header>
              {{
                formLabelAlign.activityType === 0
                  ? "优惠券"
                  : formLabelAlign.activityType === 1
                  ? "折扣券"
                  : "未定义"
              }}有效期：
            </header>
            <el-input
              placeholder="请输入有效期"
              v-model="formLabelAlign.couponEnd"
              :disabled="statusPop === 2"
            >
              <template slot="append">月</template>
            </el-input>
          </el-col>
          <el-col :span="24">
            <header>备注：</header>
            <el-input
              :disabled="statusPop === 2"
              placeholder="请输入备注"
              v-model="formLabelAlign.description"
            />
          </el-col>
        </el-col>
        <el-col :span="12">
          <el-col :span="24">
            <header>活动图标：</header>
            <div class="imgBox">
              <label class="imgLabel" for="inputs">
                <div class="msPhoto" v-if="formLabelAlign.activityLogo">
                  <img
                    :src="
                      $methodsTools.splitImgHost(formLabelAlign.activityLogo)
                    "
                    alt="图片加载失败"
                  />
                </div>
                <div class="imgbbx" v-else>
                  <p style="margin-top: 49px">点击添加或将文件拖拽到这里上传</p>
                  <i class="el-icon-plus"></i>
                  <p style="margin-bottom: 37px">
                    图片格式：.jpg/.png/jpeg/bmp
                  </p>
                </div>
                <input
                  id="inputs"
                  type="file"
                  ref="file"
                  :disabled="statusPop === 2"
                  style="display: none"
                  @change="getImgFile"
                />
              </label>
              <p>请上传分辨率为100x100且大小小于2m的图片</p>
            </div>
          </el-col>
          <el-col :span="24">
            <header>活动时间：</header>
            <el-date-picker
              :disabled="statusPop === 2"
              v-model="releaseTime"
              type="datetimerange"
              range-separator="~"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              value-format="timestamp"
            >
            </el-date-picker>
          </el-col>
          <el-col :span="24" v-if="formLabelAlign.activityType === 2">
            <header>直播内容：</header>
            <el-input
              :disabled="statusPop === 2"
              placeholder="请输入直播内容"
              v-model="formLabelAlign.liveContent"
            />
          </el-col>
          <el-col :span="24" v-if="formLabelAlign.activityType !== 2">
            <header>发放数量：</header>
            <el-input-number
              :disabled="statusPop === 2"
              v-model="formLabelAlign.quantity"
              controls-position="right"
              :min="0"
              style="width: 100%"
            ></el-input-number>
          </el-col>
        </el-col>
      </el-row>
      <div slot="footer" class="dialog-footer">
        <el-button @click="closeBefore">取 消</el-button>
        <el-button
          type="primary"
          @click="rulesTableSumbit"
          v-if="statusPop !== 2"
          >确 定</el-button
        >
      </div>
    </el-dialog>
  </div>
</template>

<script>
import searchBox from "@/components/searchBox";
import tableList from "@/components/tableList";
import pagination from "@/components/pagination";
export default {
  components: { searchBox, tableList, pagination },
  data() {
    return {
      loading: false, //当前表单加载是否加载动画
      navText: {
        title: "活动配置",
        index: 0,
        ch: "条",
        num: true,
        choice: true,
        addHide: false,
        backFatherBtn: {
          status: false,
          title: "未定义",
        },
      },
      statusPop: 0,
      fullscreen: false,
      dialogBox: false,
      activityList: [
        {
          label: "优惠券",
          value: 0,
        },
        {
          label: "折扣券",
          value: 1,
        },
        {
          label: "线上直播",
          value: 2,
        },
        {
          label: "定价",
          value: 3,
        },
        {
          label: "优惠",
          value: 4,
        },
        {
          label: "折扣",
          value: 5,
        },
      ],
      //搜索
      formList: [
        {
          label: "活动类型",
          prop: "activityType",
          placeholder: "请选择活动类型",
          scope: "select",
          options: [
            {
              label: "优惠券",
              value: 0,
            },
            {
              label: "折扣券",
              value: 1,
            },
            {
              label: "线上直播",
              value: 2,
            },
            {
              label: "定价",
              value: 3,
            },
            {
              label: "优惠",
              value: 4,
            },
            {
              label: "折扣",
              value: 5,
            },
          ],
        },
        {
          label: "活动状态",
          prop: "status",
          placeholder: "请选择活动状态",
          scope: "select",
          options: [
            {
              label: "已删除",
              value: 0,
            },
            {
              label: "已结束",
              value: 1,
            },
            {
              label: "已撤回",
              value: 2,
            },
            {
              label: "已开始",
              value: 3,
            },
            {
              label: "未开始",
              value: 4,
            },
          ],
        },
        {
          label: "活动时间",
          prop: "startTimeList",
          scope: "datePicker",
        },
        {
          label: "活动名称",
          prop: "activityName",
          placeholder: "请输入活动名称",
        },
      ],
      // 表单
      tableSet: [
        {
          label: "活动名称",
          prop: "activityName",
          hidden: true,
        },
        {
          label: "活动类型",
          prop: "activityType",
          hidden: true,
          scope: "activityType",
        },
        {
          label: "活动说明",
          prop: "activityType",
          hidden: true,
          scope: "activityRemarks",
        },
        {
          label: "活动时间",
          prop1: "startTime",
          prop2: "endTime",
          hidden: true,
          scope: "TimeLists",
        },
        {
          label: "活动状态",
          prop: "status",
          hidden: true,
          scope: "statusActivity",
        },
        {
          label: "发放数量",
          prop: "quantity",
          hidden: true,
        },
        {
          label: "参与人数",
          prop: "userNumber",
          hidden: true,
        },
        {
          label: "备注",
          prop: "description",
          hidden: true,
        },
      ],
      formLabelAlign: {},
      releaseTime: [],
      tableData: [], //表单数据
      total: 0, //一共多少条
      pageSize: 10, //每页多少条数据
      currentPage: 1, //当前页码
      beif: {},
      courseList: [],
    };
  },
  mounted() {
    this.search();
    this.getCourse();
  },
  methods: {
    getCourse() {
      this.$api
        .inquireCourseList({
          status: 1,
        })
        .then((res) => {
          if (res.code === 200) {
            this.courseList = res.rows;
          }
        });
    },
    getImgFile() {
      var self = this;
      var file = this.$refs.file.files[0];
      if (file === undefined) {
        self.$set(self.formLabelAlign, "activityLogo", "");
        return;
      }
      if (file.size > 2 * 1024 * 1024) {
        this.$message.error("图片不得大于2MB");
        return;
      }
      var type = this.$refs.file.value.toLowerCase().split(".").splice(-1);
      if (
        type[0] != "jpg" &&
        type[0] != "png" &&
        type[0] != "jpeg" &&
        type[0] != "bmp"
      ) {
        this.$message.error("上传格式需为：.jpg/.png/.jpeg/bmp");
        this.$refs.file.value = "";
        return;
      }
      var reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = function (ev) {
        self.$set(self.formLabelAlign, "activityLogo", ev.target.result);
      };
    },
    search(v) {
      this.loading = true;
      if (v === undefined) {
        v = {
          pageSize: this.pageSize,
          pageNum: this.currentPage,
        };
      }
      var data = {
        activityName: v.activityName,
        status: v.status,
        activityType: v.activityType,
        startTime: v.startTimeList ? (v.startTimeList[0] / 1000).toFixed(0) : "",
        endTime: v.startTimeList ? (v.startTimeList[1] / 1000).toFixed(0) : "",
        pageSize: this.pageSize,
        pageNum: this.currentPage,
      };
      this.$api.inquireActiveConfiguration(data).then((res) => {
        this.tableData = res.rows;
        this.total = res.total;
        this.navText.index = res.total;
      });
      this.loading = false;
    },
    init() {
      this.search();
    },
    addClick(v, int) {
      if (int === undefined) {
        this.statusPop = 1;
        this.formLabelAlign = {};
      } else {
        this.beif = JSON.stringify(v);
        this.formLabelAlign = JSON.parse(this.beif);
        this.releaseTime = [
          this.formLabelAlign.startTime * 1000,
          this.formLabelAlign.endTime * 1000,
        ];
        this.statusPop = int;
      }
      this.dialogBox = true;
    },
    closeBefore() {
      if (this.statusPop === 2) {
        this.dialogBox = false;
        this.fullscreen = false;
      } else {
        this.$confirm("此操作将关闭窗口, 是否继续?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.dialogBox = false;
            this.fullscreen = false;
            this.formLabelAlign = {};
          })
          .catch(() => {});
      }
    },
    async rulesTableSumbit() {
      if (!this.formLabelAlign.activityName) {
        this.$message.error("请输入活动名称");
        return;
      }
      if (
        this.formLabelAlign.activityLogo === "" ||
        this.formLabelAlign.activityLogo === undefined
      ) {
        this.$message.error("请上传活动图标");
        return;
      }
      if (!this.formLabelAlign.activityUrl) {
        this.$message.error("请输入跳转链接");
        return;
      }
      if (!this.releaseTime) {
        this.$message.error("请选择活动时间");
        return;
      }
      if (this.formLabelAlign.activityType !== 2) {
        if (this.formLabelAlign.courses.length === 0) {
          this.$message.error("请选择活动范围");
          return;
        }
        if (
          this.formLabelAlign.price === "" ||
          this.formLabelAlign.price == undefined ||
          this.formLabelAlign.price === null
        ) {
          this.$message.error("请选择金额/折扣/优惠金额");
          return;
        }
        if (
          this.formLabelAlign.quantity === "" ||
          this.formLabelAlign.quantity == undefined ||
          this.formLabelAlign.quantity === null
        ) {
          this.$message.error("请输入发放数量");
          return;
        }
      } else {
        if (!this.formLabelAlign.liveContent) {
          this.$message.error("请输入直播内容");
          return;
        }
      }
      if (this.statusPop === 0) {
        var objNew = JSON.parse(this.beif);
        if (this.formLabelAlign.activityLogo !== objNew.activityLogo) {
          const awtimg = await this.imgUpload(0);
        }
      } else {
        const awtimg = await this.imgUpload(0);
      }
      var data = {
        activityName: this.formLabelAlign.activityName,
        activityUrl: this.formLabelAlign.activityUrl,
        activityType: this.formLabelAlign.activityType,
        startTime: Number(this.releaseTime[0]) / 1000,
        endTime: Number(this.releaseTime[1]) / 1000,
        description: this.formLabelAlign.description,
        activityLogo: this.formLabelAlign.activityLogo,
      };
      if (this.formLabelAlign.activityType !== 2) {
        if (
          this.formLabelAlign.activityType === 0 ||
          this.formLabelAlign.activityType === 1
        ) {
          data.couponEnd = this.formLabelAlign.couponEnd;
        }
        data.coursesId = this.formLabelAlign.courses;
        data.price = this.formLabelAlign.price;
        data.quantity = this.formLabelAlign.quantity;
      } else {
        data.liveContent = this.formLabelAlign.liveContent;
      }
      if (this.statusPop === 1) {
        data.status = 4;
        this.$api.addActiveConfiguration(data).then((sult) => {
          this.$message.success("添加成功!");
          this.dialogBox = false;
          this.search();
        });
      } else {
        data.id = this.formLabelAlign.id;
        data.status = this.formLabelAlign.status;
        this.$api.editActiveConfiguration(data).then((sult) => {
          this.$message.success("修改成功!");
          this.dialogBox = false;
          this.search();
        });
      }
    },
    changeStatus(v, int) {
      var self = this;
      var data = {
        id: v.id,
        status: int,
      };
      this.$api.editActiveConfiguration(data).then((res) => {
        if (res.code === 200) {
          if (int === 0) {
            self.$message.success("删除成功");
          } else if (int === 1) {
            self.$message.success("结束成功");
          } else if (int === 2) {
            self.$message.success("撤回成功");
          } else if (int === 3) {
            self.$message.success("开始成功");
          }
          this.search();
        }
      });
    },
    imgUpload(int) {
      return new Promise((resolve, reject) => {
        this.$upload
          .upload(this.$refs.file.files[0], int)
          .then((res) => {
            console.log(res);
            this.$set(this.formLabelAlign, "activityLogo", res);
            resolve();
          })
          .catch((err) => {
            this.$message.error("图片上传错误");
          });
      });
    },
    handleSizeChange(v) {
      this.pageSize = v;
      this.currentPage = 1;
      this.search();
    },
    handleCurrentChange(v) {
      this.currentPage = v;
      this.search();
    },
  },
};
</script>

<style lang="less" scoped>
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__body {
    padding: 0;
    .contentBox {
      padding: 20px 20px 5px;
      .el-col {
        padding: 0px 20px;
        margin-bottom: 30px;
        header {
          margin-bottom: 6px;
          color: #2f4378;
          font-size: 14px;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
  }
}
.imgBox {
  width: 100%;
  // height: 210px;
  border: 1px solid #e2e2e2;
  border-radius: 8px;
  padding: 8px 8px 3px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .imgLabel {
    flex: 1;
    width: 100%;
    border: 1px dotted #e2e2e2;
    color: #999;
    font-size: 14px;
    cursor: pointer;
    border-radius: 8px;
    .msPhoto {
      display: flex;
      justify-content: center;
      align-items: center;
      max-width: 100%;
      max-height: 270px;
      img {
        max-width: 100%;
        max-height: 270px;
      }
    }
    .imgbbx {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      i {
        font-weight: bold;
        margin: 14px 0;
        font-size: 24px;
      }
    }
  }
  p {
    margin: 5px 0px;
  }
}
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
}
</style>

